routes/web.php
<?php

use Illuminate\Support\Facades\Artisan;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
Route::get('/clear', function() {
    Artisan::call('cache:clear');
    Artisan::call('config:clear');
    Artisan::call('config:cache');
    Artisan::call('view:clear');
    return "Cleared!";
});
Auth::routes(['register'=>false]);

Route::get('/', 'HomeController@welcome')->name('welcome');
Route::get('/home', 'HomeController@index')->name('home');
Route::get('/product/{id}', 'HomeController@product')->name('product');
Route::get('/our/product', 'HomeController@ourProduct')->name('our.product');
Route::get('/about/us', 'HomeController@aboutUs')->name('about.us');
Route::get('/contact/us', 'HomeController@contactUs')->name('contact.us');

Route::group(['as'=>'admin.','prefix'=>'admin','namespace'=>'Admin','middleware'=>['auth','admin','history']], function () {
    Route::get('/dashboard','DashboardController@index')->name('dashboard');

    Route::get('/logo/name','DashboardController@logoName')->name('logo.name');
    Route::put('/logo/name/update','DashboardController@logoNameUpdate')->name('logo.name.update');

    Route::get('/social','DashboardController@social')->name('social');
    Route::put('/social/update','DashboardController@socialUpdate')->name('social.update');

    Route::get('/contact','DashboardController@contact')->name('contact');
    Route::put('/contact/update','DashboardController@contactUpdate')->name('contact.update');

    Route::get('/about/us','DashboardController@aboutUs')->name('about.us');
    Route::put('/about/us/update','DashboardController@aboutUsUpdate')->name('about-us.update');

    Route::get('/category/add','CategoryController@category')->name('category');
    Route::post('/category/add/add','CategoryController@categoryAdd')->name('category.add');
    Route::get('/category/view','CategoryController@categoryView')->name('category.view');
    Route::get('/category/edit{id}','CategoryController@categoryEdit')->name('category.edit');
    Route::put('/category/update{id}','CategoryController@categoryUpdate')->name('category.update');
    Route::delete('/category/delete{id}','CategoryController@categoryDelete')->name('category.delete');

    Route::get('/product/add','ProductController@product')->name('product');
    Route::post('/product/add/add','ProductController@productAdd')->name('product.add');
    Route::get('/product/{id}edit','ProductController@productedit')->name('product.edit');
    Route::get('/product/view','ProductController@productView')->name('product.view');
    Route::put('/product{id}/update','ProductController@productUpdate')->name('product.update');
    Route::delete('/product/delete{id}','ProductController@productDelete')->name('product.delete');

});

app/Product.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Product extends Model
{
    public function category(){
       return $this->belongsTo(Category::class);
    }
}

app/Http/Controllers/Admin/ProductController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Category;
use App\Http\Controllers\Controller;
use App\Product;
use Brian2694\Toastr\Facades\Toastr;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Storage;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Str;
use Intervention\Image\Facades\Image;

class ProductController extends Controller
{
    public function product(){
        //dd('Bahari'.str_pad(mt_rand(100,999),3,3,STR_PAD_LEFT));
        $categories = Category::all();
        return view('Admin.Product.create',compact('categories'));
    }
    public function productAdd(Request $request, Product $product){
        $val = Validator::make($request->all(),[
            'name' => 'required|string|max:191',
            'price'=>'required|integer|not_in:0',
            'description'=>'required|string',
            'condition'=>'required|string',
            'category'=>'required|integer|not_in:0|exists:categories,id',
            'image1'=>'required|image|mimes:jpg,jpeg,png,gif',
            'image2'=>'required|image|mimes:jpg,jpeg,png,gif',
        ]);
        if ($val->fails()){
            Toastr::error('Invalid Request','Error');
            return redirect()->withInput();
        }

        //get from image
        $image1 = $request->file('image1');
        $image2 = $request->file('image2');
        if (isset($image1) && isset($image2)){
            $img1 = Str::slug($request->name).'-'.uniqid().'.'.$image1->getClientOriginalExtension();
            $img2 = Str::slug($request->name).'-'.uniqid().'.'.$image2->getClientOriginalExtension();
            //check category dir is exits
            if (!Storage::disk('public')->exists('product')){
                Storage::disk('public')->makeDirectory('product');
            }
            $pImg1 = Image::make($image1)->resize(400,300)->save();
            Storage::disk('public')->put('product/'.$img1,$pImg1);
            $pImg2 = Image::make($image2)->resize(400,300)->save();
            Storage::disk('public')->put('product/'.$img2,$pImg2);

            $product->name = $request->name;//str_pad(mt_rand(0, 999999), 6, '0', STR_PAD_LEFT)
            $product->code = 'Bahari'.str_pad(mt_rand(100,999),3,3,STR_PAD_LEFT);
            $product->category_id=$request->category;
            $product->price = $request->price;
            $product->description = $request->description;
            $product->condition = $request->condition;
            $product->image1 = $img1;
            $product->image2 = $img2;
            $product->save();
            Toastr::success('successfully added :)','Success');
            return redirect()->back();
        }
        Toastr::error('Invalid Request','Error');
        return redirect()->back();

    }
    public function productView(){
        $products = Product::all();
        return view('Admin.Product.index',compact('products'));
    }
    public function productEdit($id){
        $product = Product::findOrFail($id);
        if (isset($product->id)){
            $categories = Category::all();
            return view('Admin.Product.edit',compact('product','categories'));
        }
        Toastr::error('Invalid Request','Error');
        return redirect()->back();
    }
    public function productUpdate(Request $request,$id){

        $val = Validator::make($request->all(),[
            'name' => 'required|string|max:191',
            'price'=>'required|integer|not_in:0',
            'description'=>'required|string',
            'condition'=>'required|string',
            'category'=>'required|integer|not_in:0|exists:categories,id',
            'image1'=>'image|mimes:jpg,jpeg,png,gif',
            'image2'=>'image|mimes:jpg,jpeg,png,gif',
        ]);
        if ($val->fails()){
            Toastr::error('Invalid Request','Error');
            return redirect()->withInput();
        }
        $product = Product::findOrFail($id);
        if (isset($product->id)){
            //get from image
            $image1 = $request->file('image1');
            $image2 = $request->file('image2');
            if (isset($image1) && isset($image2)){
                $img1 = Str::slug($request->name).'-'.uniqid().'.'.$image1->getClientOriginalExtension();
                $img2 = Str::slug($request->name).'-'.uniqid().'.'.$image2->getClientOriginalExtension();
                //check category dir is exits
                if (!Storage::disk('public')->exists('product')){
                    Storage::disk('public')->makeDirectory('product');
                }
                //remove previous image
                if (Storage::disk('public')->exists('product/'.$product->image1)){
                    Storage::disk('public')->delete('product/'.$product->image1);
                }
                if (Storage::disk('public')->exists('product/'.$product->image2)){
                    Storage::disk('public')->delete('product/'.$product->image2);
                }

                $pImg1 = Image::make($image1)->resize(400,300)->save();
                Storage::disk('public')->put('product/'.$img1,$pImg1);
                $pImg2 = Image::make($image2)->resize(400,300)->save();
                Storage::disk('public')->put('product/'.$img2,$pImg2);
            }else{
                $img1=$product->image1;
                $img2=$product->image2;
            }
            $product->name = $request->name;
            $product->category_id=$request->category;
            $product->price = $request->price;
            $product->description = $request->description;
            $product->condition = $request->condition;
            $product->image1 = $img1;
            $product->image2 = $img2;
            $product->save();
            Toastr::success('successfully update :)','Success');
            return redirect()->back();
        }
        Toastr::error('Invalid Request','Error');
        return redirect()->back();
    }
    public function productDelete($id){
        $pod = Product::findOrFail($id);
        if (isset($pod->id)){
            if (Storage::disk('public')->exists('product/'.$pod->image1)){
                Storage::disk('public')->delete('product/'.$pod->image1);
            }
            if (Storage::disk('public')->exists('product/'.$pod->image2)){
                Storage::disk('public')->delete('product/'.$pod->image2);
            }
            $pod->delete();
            Toastr::success('Delete successfully','Success');
            return redirect()->back();
        }
        Toastr::error('Invalid Request','Error');
        return redirect()->back();
    }
}

resources/views/Admin/Product/create.blade.php
@extends('layouts.backend.app')

@section('title','Create')

@push('css')
    <!-- Bootstrap Select Css -->
    <link href="{{ asset('assets/backend/plugins/bootstrap-select/css/bootstrap-select.css') }}" rel="stylesheet" />
@endpush


@section('content')
    <div class="container-fluid">

        <!-- Vertical Layout | With Floating Label -->
        <div class="row clearfix">
            <form action="{{ route('admin.product.add') }}" method="POST" enctype="multipart/form-data">
                @csrf
                <div class="col-lg-8 col-md-12 col-sm-12 col-xs-12">
                    <div class="card">
                        <div class="header">
                            <h2>
                                Add new Product
                            </h2>
                        </div>
                        <div class="body">
                            <div class="form-group form-float">
                                <div class="form-line">
                                    <input type="text" id="name" class="form-control" name="name">
                                    <label class="form-label">Food Name*</label>
                                </div>
                            </div>
                            <div class="form-group form-float">
                                <div class="form-line">
                                    <input type="float" id="price" class="form-control" name="price">
                                    <label class="form-label">Price per Kg*</label>
                                </div>
                            </div>
                            <div class="form-group">
                                <label class="form-label">Upload Images 1</label>
                                <input type="file" name="image1">
                            </div>
                            <div class="form-group">
                                <label class="form-label">Upload Images 2</label>
                                <input type="file" name="image2">
                            </div>
                            <div class="form-group">
                                <label class="form-label">Description</label>
                                <textarea class="form-control" id="description" rows="5" name="description" style="outline: none !important;border-color: #719ECE;box-shadow: 0 0 10px #719ECE;"> </textarea>
                            </div>
                            <div class="form-group">
                                <label class="form-label">Condition</label>
                                <textarea class="form-control" id="condition" rows="5" name="condition" style="outline: none !important;border-color: #719ECE;box-shadow: 0 0 10px #719ECE;"> </textarea>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="col-lg-4 col-md-12 col-sm-12 col-xs-12">
                    <div class="card">
                        <div class="header">
                            <h2>
                                Categories
                            </h2>
                        </div>
                        <div class="body">
                            <div class="form-group form-float">
                                <div class="form-line">
                                    <label for="category">Categories</label>
                                    <select name="category" id="category" class="form-control show-tick" data-live-search="true">
                                        @foreach($categories as $category)
                                            <option value="{{ $category->id }}">
                                                {{ $category->name }}
                                            </option>
                                        @endforeach
                                    </select>
                                </div>
                            </div>
                            <button type="submit" class="btn btn-primary m-t-15 waves-effect">Submit</button>
                        </div>
                    </div>
                </div>
            </form>
        </div>
        <!-- Vertical Layout | With Floating Label -->
    </div>

@endsection

@push('js')
    <!-- Select Plugin Js -->
    <script src="{{ asset('assets/backend/plugins/bootstrap-select/js/bootstrap-select.js') }}"></script>
@endpush

resources/views/Admin/Product/edit.blade.php
@extends('layouts.backend.app')

@section('title','Create')

@push('css')
    <!-- Bootstrap Select Css -->
    <link href="{{ asset('assets/backend/plugins/bootstrap-select/css/bootstrap-select.css') }}" rel="stylesheet" />
@endpush


@section('content')
    <div class="container-fluid">

        <!-- Vertical Layout | With Floating Label -->
        <div class="row clearfix">
            <form action="{{ route('admin.product.update',$product->id) }}" method="POST" enctype="multipart/form-data">
                @csrf
                @method('PUT')
                <div class="col-lg-8 col-md-12 col-sm-12 col-xs-12">
                    <div class="card">
                        <div class="header">
                            <h2>
                                Update Product
                            </h2>
                        </div>
                        <div class="body">
                            <div class="form-group form-float">
                                <div class="form-line">
                                    <input type="text" id="name" value="{{$product->name}}" class="form-control" name="name">
                                    <label class="form-label">Food Name</label>
                                </div>
                            </div>
                            <div class="form-group form-float">
                                <div class="form-line">
                                    <input type="float" id="price" value="{{$product->price}}" class="form-control" name="price">
                                    <label class="form-label">Price per Kg</label>
                                </div>
                            </div>
                            <div class="form-group">
                                <label class="form-label">Upload Images 1</label>
                                <input type="file" name="image1">
                            </div>
                            <div class="form-group">
                                <label class="form-label">Upload Images 2</label>
                                <input type="file" name="image2">
                            </div>
                            <div class="form-group">
                                <label class="form-label">Description</label>
                                <textarea class="form-control" id="description" rows="5" name="description" style="outline: none !important;border-color: #719ECE;box-shadow: 0 0 10px #719ECE;">{!! $product->description !!} </textarea>
                            </div>
                            <div class="form-group">
                                <label class="form-label">Condition</label>
                                <textarea class="form-control" id="condition" rows="5" name="condition" style="outline: none !important;border-color: #719ECE;box-shadow: 0 0 10px #719ECE;"> {!! $product->condition !!}</textarea>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="col-lg-4 col-md-12 col-sm-12 col-xs-12">
                    <div class="card">
                        <div class="header">
                            <h2>
                                Categories
                            </h2>
                        </div>
                        <div class="body">
                            <div class="form-group form-float">
                                <div class="form-line">
                                    <label for="category">Categories</label>
                                    <select name="category" id="category" class="form-control show-tick" data-live-search="true">
                                        @foreach($categories as $category)
                                            <option  {{ $product->category_id == $category->id ? 'selected': ''}}
                                                     value="{{ $category->id }}">
                                                {{ $category->name }}
                                            </option>
                                        @endforeach
                                    </select>
                                </div>
                            </div>
                            <button type="submit" class="btn btn-primary m-t-15 waves-effect">Submit</button>
                        </div>
                    </div>
                </div>
            </form>
        </div>
        <!-- Vertical Layout | With Floating Label -->
    </div>

@endsection

@push('js')
    <!-- Select Plugin Js -->
    <script src="{{ asset('assets/backend/plugins/bootstrap-select/js/bootstrap-select.js') }}"></script>
@endpush

resources/views/Admin/Product/index.blade.php
@extends('layouts.backend.app')

@section('title','Food Item')

@push('css')
    <!-- JQuery DataTable Css -->
    <link href="{{ asset('assets/backend/plugins/jquery-datatable/skin/bootstrap/css/dataTables.bootstrap.css') }}" rel="stylesheet">
@endpush

@section('content')
    <div class="container-fluid">
        <div class="block-header">
            <a class="btn btn-primary waves-effect" href="{{ route('admin.product') }}">
                <i class="material-icons">add</i>
                <span>Add New Food item</span>
            </a>
        </div>
        <!-- Exportable Table -->
        <div class="row clearfix">
            <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
                <div class="card">
                    <div class="header">
                        <h2>
                            All Product
                            <span class="badge bg-blue">{{ $products->count() }}</span>
                        </h2>
                    </div>
                    <div class="body">
                        <div class="table-responsive">
                            <table class="table table-bordered table-striped table-hover dataTable js-basic-example">
                                <thead>
                                <tr>
                                    <th>SL</th>
                                    <th>Name</th>
                                    <th>Code</th>
                                    <th>Image1</th>
                                    <th>Image2</th>
                                    <th>Description</th>
                                    <th>Condition</th>
                                    <th><i class="material-icons">visibility</i></th>
                                    <th>Price</th>
                                    <th>Stock</th>
                                    <th>Action</th>
                                </tr>
                                </thead>
                                <tfoot>
                                <tr>
                                    <th>SL</th>
                                    <th>Name</th>
                                    <th>Code</th>
                                    <th>Image1</th>
                                    <th>Image2</th>
                                    <th>Description</th>
                                    <th>Condition</th>
                                    <th><i class="material-icons">visibility</i></th>
                                    <th>Price</th>
                                    <th>Stock</th>
                                    <th>Action</th>
                                </tr>
                                </tfoot>
                                <tbody>
                                @foreach($products as $key=>$post)
                                    <tr>
                                        <td>{{ $key + 1 }}</td>
                                        <td>{{ \Illuminate\Support\Str::limit($post->name,'10') }}</td>
                                        <td>{{ $post->code }}</td>
                                        <td><img src="{{ asset('public/storage/product/'.$post->image1) }}" width="50px;" height="50px;"></td>
                                        <td><img src="{{ asset('public/storage/product/'.$post->image2) }}" width="50px;" height="50px;"></td>
                                        <td>{{ \Illuminate\Support\Str::limit($post->description,'20')}}</td>
                                        <td>{{ \Illuminate\Support\Str::limit($post->condition,'20')}}</td>
                                        <td>0</td>
                                        <td>{{ $post->price }} Tk.</td>
                                        <td>
                                            @if($post->is_available == true)
                                                <span class="badge bg-blue">Available</span>
                                            @else
                                                <span class="badge bg-pink">out of Stock</span>
                                            @endif
                                        </td>
                                        {{--<td>{{ $post->updated_at }}</td>--}}
                                        <td class="text-center">
                                            <a href="{{ route('admin.product.edit',$post->id) }}" class="btn btn-info waves-effect">
                                                <i class="material-icons">edit</i>
                                            </a>
                                            <button class="btn btn-danger waves-effect" type="button" onclick="deletePost({{ $post->id }})">
                                                <i class="material-icons">delete</i>
                                            </button>
                                            <form id="delete-form-{{ $post->id }}" action="{{ route('admin.product.delete',$post->id) }}" method="POST" style="display: none;">
                                                @csrf
                                                @method('DELETE')
                                            </form>
                                        </td>
                                    </tr>
                                @endforeach
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <!-- #END# Exportable Table -->
    </div>
@endsection

@push('js')
    <!-- Jquery DataTable Plugin Js -->
    <script src="{{ asset('assets/backend/plugins/jquery-datatable/jquery.dataTables.js') }}"></script>
    <script src="{{ asset('assets/backend/plugins/jquery-datatable/skin/bootstrap/js/dataTables.bootstrap.js') }}"></script>
    <script src="{{ asset('assets/backend/plugins/jquery-datatable/extensions/export/dataTables.buttons.min.js') }}"></script>
    <script src="{{ asset('assets/backend/plugins/jquery-datatable/extensions/export/buttons.flash.min.js') }}"></script>
    <script src="{{ asset('assets/backend/plugins/jquery-datatable/extensions/export/jszip.min.js') }}"></script>
    <script src="{{ asset('assets/backend/plugins/jquery-datatable/extensions/export/pdfmake.min.js') }}"></script>
    <script src="{{ asset('assets/backend/plugins/jquery-datatable/extensions/export/vfs_fonts.js') }}"></script>
    <script src="{{ asset('assets/backend/plugins/jquery-datatable/extensions/export/buttons.html5.min.js') }}"></script>
    <script src="{{ asset('assets/backend/plugins/jquery-datatable/extensions/export/buttons.print.min.js') }}"></script>

    <script src="{{ asset('assets/backend/js/pages/tables/jquery-datatable.js') }}"></script>
    <script src="https://unpkg.com/sweetalert2@7.19.1/dist/sweetalert2.all.js"></script>
    <script type="text/javascript">
        function deletePost(id) {
            swal({
                title: 'Are you sure?',
                text: "You won't be able to revert this!",
                type: 'warning',
                showCancelButton: true,
                confirmButtonColor: '#3085d6',
                cancelButtonColor: '#d33',
                confirmButtonText: 'Yes, delete it!',
                cancelButtonText: 'No, cancel!',
                confirmButtonClass: 'btn btn-success',
                cancelButtonClass: 'btn btn-danger',
                buttonsStyling: false,
                reverseButtons: true
            }).then((result) => {
                if (result.value) {
                    event.preventDefault();
                    document.getElementById('delete-form-'+id).submit();
                } else if (
                    // Read more about handling dismissals
                    result.dismiss === swal.DismissReason.cancel
                ) {
                    swal(
                        'Cancelled',
                        'Your data is safe :)',
                        'error'
                    )
                }
            })
        }
    </script>
@endpush